"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ComponentHighlighter = void 0;
const react_1 = __importStar(require("react"));
const classnames_1 = __importDefault(require("classnames"));
const react_modules_dom_to_react_1 = require("@teambit/react.modules.dom-to-react");
const react_ui_hover_selector_1 = require("@teambit/react.ui.hover-selector");
const use_debounce_1 = require("use-debounce");
const frame_1 = require("../frame");
const label_1 = require("../label");
const bit_react_component_1 = require("./bit-react-component");
const component_highlighter_module_scss_1 = __importDefault(require("./component-highlighter.module.scss"));
function ComponentHighlighter(_a) {
    var { children, disabled } = _a, rest = __rest(_a, ["children", "disabled"]);
    const [target, setTarget] = react_1.useState();
    const _handleElement = react_1.useCallback((element) => {
        if (!element || (element === null || element === void 0 ? void 0 : element.hasAttribute('data-nullify-component-highlight'))) {
            setTarget(undefined);
            return;
        }
        const result = bubbleToBitComponent(element, (elem) => !elem.hasAttribute('data-ignore-component-highlight'));
        if (!result)
            return;
        setTarget({
            element: result.element,
            id: result.meta.id,
            scopeLink: undefined,
            link: result.meta.homepage,
            local: result.meta.exported === false,
        });
    }, []);
    const handleElement = use_debounce_1.useDebouncedCallback(_handleElement, target ? 80 : 0);
    react_1.useEffect(() => {
        if (disabled) {
            setTarget(undefined);
        }
    }, [disabled]);
    return (react_1.default.createElement(react_ui_hover_selector_1.HoverSelector, Object.assign({}, rest, { className: classnames_1.default(component_highlighter_module_scss_1.default.highlighter, !disabled && component_highlighter_module_scss_1.default.active), onElementChange: handleElement, disabled: disabled, "data-nullify-component-highlight": true }),
        children,
        target && (react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement(frame_1.Frame, { targetRef: target.element, "data-ignore-component-highlight": true }),
            target.id && (react_1.default.createElement(label_1.LabelContainer, { className: component_highlighter_module_scss_1.default.label, targetRef: target.element, placement: "top", "data-ignore-component-highlight": true },
                react_1.default.createElement(label_1.Label, { componentId: target.id, link: target.link, scopeLink: target.scopeLink, local: target.local, "data-ignore-component-highlight": true })))))));
}
exports.ComponentHighlighter = ComponentHighlighter;
function bubbleToBitComponent(element, filter) {
    for (let current = element; current; current = current.parentElement) {
        current = react_modules_dom_to_react_1.toRootElement(current);
        if (!current || (filter === null || filter === void 0 ? void 0 : filter(current)) === false)
            return undefined;
        const component = react_modules_dom_to_react_1.domToReact(current);
        if (bit_react_component_1.hasComponentMeta(component)) {
            const meta = component.__bit_component;
            return {
                element: current,
                component,
                meta,
            };
        }
    }
    return undefined;
}
//# sourceMappingURL=component-highlighter.js.map